
.text




.code 32



.align 5
.globl OPENSSL_atomic_add
.type OPENSSL_atomic_add,%function
OPENSSL_atomic_add:

.Ladd: ldrex r2,[r0]
 add r3,r2,r1
 strex r2,r3,[r0]
 cmp r2,#0
 bne .Ladd
 mov r0,r3
 bx lr
.size OPENSSL_atomic_add,.-OPENSSL_atomic_add

.globl OPENSSL_cleanse
.type OPENSSL_cleanse,%function
OPENSSL_cleanse:
 eor ip,ip,ip
 cmp r1,#7



 subhs r1,r1,#4
 bhs .Lot
 cmp r1,#0
 beq .Lcleanse_done
.Little:
 strb ip,[r0],#1
 subs r1,r1,#1
 bhi .Little
 b .Lcleanse_done

.Lot: tst r0,#3
 beq .Laligned
 strb ip,[r0],#1
 sub r1,r1,#1
 b .Lot
.Laligned:
 str ip,[r0],#4
 subs r1,r1,#4
 bhs .Laligned
 adds r1,r1,#4
 bne .Little
.Lcleanse_done:

 bx lr





.size OPENSSL_cleanse,.-OPENSSL_cleanse

.globl CRYPTO_memcmp
.type CRYPTO_memcmp,%function
.align 4
CRYPTO_memcmp:
 eor ip,ip,ip
 cmp r2,#0
 beq .Lno_data
 stmdb sp!,{r4,r5}

.Loop_cmp:
 ldrb r4,[r0],#1
 ldrb r5,[r1],#1
 eor r4,r4,r5
 orr ip,ip,r4
 subs r2,r2,#1
 bne .Loop_cmp

 ldmia sp!,{r4,r5}
.Lno_data:
 neg r0,ip
 mov r0,r0,lsr#31

 bx lr





.size CRYPTO_memcmp,.-CRYPTO_memcmp


.arch armv7-a
.fpu neon

.align 5
.globl _armv7_neon_probe
.type _armv7_neon_probe,%function
_armv7_neon_probe:
 vorr q0,q0,q0
 bx lr
.size _armv7_neon_probe,.-_armv7_neon_probe

.globl _armv7_tick
.type _armv7_tick,%function
_armv7_tick:



 mrrc p15,1,r0,r1,c14 @ CNTVCT

 bx lr
.size _armv7_tick,.-_armv7_tick

.globl _armv8_aes_probe
.type _armv8_aes_probe,%function
_armv8_aes_probe:



.byte 0x00,0x03,0xb0,0xf3 @ aese.8 q0,q0

 bx lr
.size _armv8_aes_probe,.-_armv8_aes_probe

.globl _armv8_sha1_probe
.type _armv8_sha1_probe,%function
_armv8_sha1_probe:



.byte 0x40,0x0c,0x00,0xf2 @ sha1c.32 q0,q0,q0

 bx lr
.size _armv8_sha1_probe,.-_armv8_sha1_probe

.globl _armv8_sha256_probe
.type _armv8_sha256_probe,%function
_armv8_sha256_probe:



.byte 0x40,0x0c,0x00,0xf3 @ sha256h.32 q0,q0,q0

 bx lr
.size _armv8_sha256_probe,.-_armv8_sha256_probe
.globl _armv8_pmull_probe
.type _armv8_pmull_probe,%function
_armv8_pmull_probe:



.byte 0x00,0x0e,0xa0,0xf2 @ vmull.p64 q0,d0,d0

 bx lr
.size _armv8_pmull_probe,.-_armv8_pmull_probe


.globl OPENSSL_wipe_cpu
.type OPENSSL_wipe_cpu,%function
OPENSSL_wipe_cpu:

 ldr r0,.LOPENSSL_armcap
 adr r1,.LOPENSSL_armcap
 ldr r0,[r1,r0]




 eor r2,r2,r2
 eor r3,r3,r3
 eor ip,ip,ip

 tst r0,#1
 beq .Lwipe_done
 veor q0, q0, q0
 veor q1, q1, q1
 veor q2, q2, q2
 veor q3, q3, q3
 veor q8, q8, q8
 veor q9, q9, q9
 veor q10, q10, q10
 veor q11, q11, q11
 veor q12, q12, q12
 veor q13, q13, q13
 veor q14, q14, q14
 veor q15, q15, q15
.Lwipe_done:

 mov r0,sp

 bx lr





.size OPENSSL_wipe_cpu,.-OPENSSL_wipe_cpu

.globl OPENSSL_instrument_bus
.type OPENSSL_instrument_bus,%function
OPENSSL_instrument_bus:
 eor r0,r0,r0

 bx lr





.size OPENSSL_instrument_bus,.-OPENSSL_instrument_bus

.globl OPENSSL_instrument_bus2
.type OPENSSL_instrument_bus2,%function
OPENSSL_instrument_bus2:
 eor r0,r0,r0

 bx lr





.size OPENSSL_instrument_bus2,.-OPENSSL_instrument_bus2

.align 5

.LOPENSSL_armcap:
.word OPENSSL_armcap_P-.


.align 5
.comm OPENSSL_armcap_P,4,4
.hidden OPENSSL_armcap_P
